﻿angular.module('ScoutCartolaApp.controllers').controller('EscalacaoSugestaoCtrl', function ($scope, $ionicModal, $http, $ionicLoading, $state, sessionService, $ionicPopup, cacheService, $filter) {

    var orderBy = $filter('orderBy');

    $scope.items = [];
    $scope.storageLocal = { formacaoSelecionada: 1, patrimonioLocal: 100 };    
    $scope.valorTime = 0;
    $scope.formacoesLocal = [];

    $scope.CarregarTela = function ()
    {        
        $scope.storageLocal.formacaoSelecionada = $scope.EscalacaoModel.formacao;
        $scope.formacoesLocal = $scope.Formacoes;                

        if ($scope.EscalacaoModel.logado)
            $scope.storageLocal.patrimonioLocal = $scope.EscalacaoModel.patrimonio;
    };

    $scope.ObterTime = function () {
        if ($scope.storageLocal.patrimonioLocal == undefined) {
            $scope.customAlert('Informe um patrimônio válido.');
            return;
        }

        if ($scope.storageLocal.patrimonioLocal == 0) {
            $scope.customAlert('Informe seu patrimônio ou faça login para buscarmos ele automaticamente.');
            return;
        }

        if ($scope.EscalacaoModel.logado && $scope.storageLocal.patrimonioLocal > $scope.EscalacaoModel.patrimonio) {
            $scope.customAlert('O patrimônio informado não pode ser maior que o patrimônio real.');
            return;
        }

        var formacao = null;
        for (var i = 0; i < $scope.Formacoes.length; i++)
            if ($scope.Formacoes[i].id == $scope.storageLocal.formacaoSelecionada)
                formacao = $scope.Formacoes[i]; 

        var formacaoString = formacao.posicoes[0] + ',' + formacao.posicoes[1] + ',' + formacao.posicoes[2] + ',' + formacao.posicoes[3] + ',' + formacao.posicoes[4] + ',' + formacao.posicoes[5]; 

        var url = null;
        url = $scope.ObterRotaPadrao('API/ServicesJogador/ObterSugestaoEscalacao?versaoBase=' + cacheService.getVersaoBancoLocal() + '&formacao=' + formacaoString + '&patrimonio=' + $scope.storageLocal.patrimonioLocal);

        $scope.ExibirLoading();

        $scope.WebApi(url,
              function (data) {
                  if (typeof (data.sucesso) == 'undefined')
                      $scope.customAlert($scope.msgErroPadrao);

                  if (data.sucesso) {
                      var result = cacheService.tratarConsultaJogadoresEscalacaoComCache(data.data);

                      result.data = orderBy(result.data, 'posicaoId', false);

                      // se houver algum problema no tratamento do cache, exibe a mensagem de erro para que o usuário tente de novo, 
                      // porém essa tentativa vai gerar um resultado no padrão antigo
                      if (!result.sucesso) {
                          $scope.EsconderLoading();
                          $scope.customAlert($scope.msgErroPadrao);
                      }
                      else {
                          $scope.items = result.data;
                          var soma = 0;
                          for (var i = 0; i < $scope.items.length; i++)
                              soma += $scope.items[i].valor;

                          $scope.valorTime = soma;
                      }
                  }
                  else {
                      $scope.customAlert(data.message);
                  }

                  $scope.EsconderLoading();
              });
    };

    $scope.TentarMudarFormacao = function (indice) {        
        $scope.items = [];
    };

    $scope.QueroEsseTime = function (indice) {
        if (!$scope.EscalacaoModel.logado) {
            $scope.customAlert("Você precisa estar logado para escalar seu time!");
            return;
        }

        $scope.ExecutarVenderTodos();
        $scope.TrocarFormacao($scope.storageLocal.formacaoSelecionada);
        for (var i = 0; i < $scope.items.length; i++)
            $scope.EscalarJogador(-1, $scope.items[i]);                
    };

    $scope.CarregarTela();
})

