﻿angular.module('ScoutCartolaApp.controllers').controller('ScoutConfrontationCtrl', function ($scope, $ionicModal, $http, $ionicLoading, $window, cacheService, sessionService) {
 
    $scope.partidas = [];
    
    $scope.doRefresh = function () {
        $scope.PesquisarPartidas();
    };
    
    $scope.PesquisarPartidas = function () {

        if (sessionService.getPartidas().length != 0) // carregar os times previamente carregados antes de detalhar um time, o objetivo é não ir no servidor novamente
        {
            $scope.partidas = sessionService.getPartidas();
            sessionService.salvarPartidas([]);
        }
        else {
            var url = null;
            url = $scope.ObterRotaPadrao('API/ServicesTimes/ObterDadosEstatisticasConfrontos?versaoBase=' + cacheService.getVersaoBancoLocal());
            
            $scope.ExibirLoading();

            $scope.WebApi(url,
                function (data) {
                    if (typeof (data.sucesso) == 'undefined')
                        $scope.customAlert($scope.msgErroPadrao);

                    
                    if (data.sucesso) {
                        var result = cacheService.tratarConsultaPartidasComCache(data.data);

                        // se houver algum problema no tratamento do cache, exibe a mensagem de erro para que o usuário tente de novo, 
                        // porém essa tentativa vai gerar um resultado no padrão antigo
                        if (!result.sucesso) {
                            $scope.EsconderLoading();
                            $scope.customAlert($scope.msgErroPadrao);
                        }
                        else {
                            $scope.partidas = result.data;
                        }
                    }
                    else {
                        $scope.customAlert(data.message);
                    }

                    $scope.EsconderLoading();
                });
        }

    };

    $scope.Detalhar = function (item) {
        console.log(item);        
        sessionService.salvarPartidas($scope.partidas);
        sessionService.salvarPartida(item);
        $window.location.href = 'index.html#/app/scoutconfrontosDetalhe';
    };

    $scope.PesquisarPartidas();
})

