﻿angular.module('ScoutCartolaApp.controllers').controller('ScoutPlayerCtrl', function ($scope, $ionicModal, $http, $ionicLoading, cacheService, sessionService, $state, $filter) {

    var orderBy = $filter('orderBy');

    $scope.itemsPorPagina = 30;
    $scope.indiceAtual = 0;
    $scope.carregarMais = false;

    $scope.items = [];
    $scope.itemsListaCheia = [];
    
    $scope.filtro = {
        "rankingFiltro": "G",
        "goleiroFiltro": false,
        "lateralFiltro": false,
        "zagueiroFiltro": false,
        "meiaFiltro": false,
        "atacanteFiltro": false,
        "penaltiFiltro": false,
        "escanteioFiltro": false,
        "faltaFiltro": false,
        "StatusJogadorProvavelFiltro": true
    };

    $scope.ordenacao = { coluna: "VAL" };

    $scope.filtroModal = {
        "rankingFiltro": "G",
        "goleiroFiltro": false,
        "lateralFiltro": false,
        "zagueiroFiltro": false,
        "meiaFiltro": false,
        "atacanteFiltro": false,
        "penaltiFiltro": false,
        "escanteioFiltro": false,
        "faltaFiltro": false,
        "StatusJogadorProvavelFiltro": true
    };

    $scope.timesSelecionados = [];
    
    $scope.classButtonTotal = '';
    $scope.classButtonMedia = '';
    $scope.rankingAtual = '';

    $scope.visao = 'T';    

    $scope.variacao = -0.6;

    // Create the login modal that we will use later
    $ionicModal.fromTemplateUrl('templates/filterJogador.html', {
        scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
    });

    $scope.Filtrar = function () {        
        $scope.modal.show();
    };

    $scope.Fechar = function () {
        $scope.modal.hide();
    };
    
    $scope.AplicarFiltros = function () {
        $scope.modal.hide();
        $scope.timesSelecionados = [];

        for (var i = 0; i < $scope.times.length; i++) {            
            if ($scope.times[i].checked)
                $scope.timesSelecionados.push($scope.times[i].id);
        }
        
        $scope.filtro.goleiroFiltro = $scope.filtroModal.goleiroFiltro;
        $scope.filtro.lateralFiltro = $scope.filtroModal.lateralFiltro;
        $scope.filtro.zagueiroFiltro = $scope.filtroModal.zagueiroFiltro;
        $scope.filtro.meiaFiltro = $scope.filtroModal.meiaFiltro;
        $scope.filtro.atacanteFiltro = $scope.filtroModal.atacanteFiltro;
        $scope.filtro.penaltiFiltro = $scope.filtroModal.penaltiFiltro;
        $scope.filtro.escanteioFiltro = $scope.filtroModal.escanteioFiltro;
        $scope.filtro.faltaFiltro = $scope.filtroModal.faltaFiltro;

        $scope.filtro.StatusJogadorProvavelFiltro = $scope.filtroModal.StatusJogadorProvavelFiltro;

        $scope.Pesquisar();
    };

    $scope.Pesquisar = function (visao) {
        
        var mudancaFiltro = false;
        if ($scope.rankingAtual != $scope.filtro.rankingFiltro) // se houver troca de indice
        {
            $scope.campoOrdem = 'total';
            $scope.ordemReversa = false; // inicializa com um valor padrão para evitar erros
            mudancaFiltro = true;
            $scope.rankingAtual = $scope.filtro.rankingFiltro;
        }

        $scope.ExibirLoading();

        var listaTimes = $scope.ObterTimes();
        var listaPosicoes = $scope.ObterPosicoes();

        var url = $scope.ObterRotaPadrao('API/ServicesJogador/ObterDadosJogadoresV2?'
            + 'codigoIndice=' + ($scope.rankingAtual == null || $scope.rankingAtual == '' ? $scope.filtro.rankingFiltro : $scope.rankingAtual)            
            + '&teamCartolaId=' + listaTimes
            + '&position=' + listaPosicoes
            + '&provaveis=' + $scope.filtroModal.StatusJogadorProvavelFiltro
            + '&falta=' + $scope.filtroModal.faltaFiltro
            + '&penalti=' + $scope.filtroModal.penaltiFiltro
            + '&escanteio=' + $scope.filtroModal.escanteioFiltro
            + '&versaoBase=' + cacheService.getVersaoBancoLocal());

        //var url = 'json/stats.json';

        $scope.WebApi(url,
            function (data) {
                if (typeof (data.sucesso) == 'undefined')
                    alert($scope.msgErroPadrao);

                if (data.sucesso) {
                    var resultCache = cacheService.tratarConsultaJogadoresComCache(data.data);
                    
                    $scope.itemsListaCheia = resultCache.data;

                    for (var i = 0; i < $scope.itemsListaCheia.length; i++)
                    {                        
                        $scope.itemsListaCheia[i].escalado = false;
                        for (var x = 0; x < $scope.EscalacaoModel.escalacao.length; x++) {                            
                            if ($scope.EscalacaoModel.escalacao[x].jogador != null && $scope.EscalacaoModel.escalacao[x].jogador.id == $scope.itemsListaCheia[i].id) {
                                $scope.itemsListaCheia[i].escalado = true;
                                break;
                            }
                        }
                    }
                    
                    $scope.classButtonTotal = 'button button-small button-customDisable';
                    $scope.classButtonMedia = 'button button-small button-customDisable';

                    if ($scope.visao == 'T')
                        $scope.classButtonTotal = 'button button-small button-custom';
                    else
                        $scope.classButtonMedia = 'button button-small button-custom';
                                                        
                    $scope.TrocarOrdenacao();
                }
                else {
                    alert(data.message);
                }                
                
                $scope.EsconderLoading();
            });

    };

    $scope.CarregarMais = function() 
    {
        $scope.carregarMais = true;

        for (var i = $scope.indiceAtual; i < $scope.indiceAtual + $scope.itemsPorPagina; i++)
        {
            $scope.items.push($scope.itemsListaCheia[i]);
            
            if (i == $scope.itemsListaCheia.length - 1)
            {
                $scope.carregarMais = false;
                break;
            }            
        }

        $scope.indiceAtual += $scope.itemsPorPagina;
    }
    
    $scope.TrocarOrdenacao = function () {                        
        $scope.indiceAtual = 0; // reiniciar exibição de items
        $scope.items = [];
        $scope.AplicarVisao();

        var campo = 'total';
        var reversa = true;

        $scope.itemsListaCheia = orderBy($scope.itemsListaCheia, 'id', false);

        if ($scope.ordenacao.coluna == 'VAL')
            campo = 'valor';
        else if ($scope.ordenacao.coluna == 'C')
            campo = 'casa';
        else if ($scope.ordenacao.coluna == 'F')
            campo = 'fora';
        else if ($scope.ordenacao.coluna == 'VALIN')
            campo = 'variacao';
        else if ($scope.ordenacao.coluna == 'VALDECR')
        {
            campo = 'variacao';
            reversa = false;
        }
        console.log($scope.items);    
        $scope.itemsListaCheia = orderBy($scope.itemsListaCheia, campo, reversa);
        $scope.CarregarMais();
    };

    $scope.AplicarVisao = function () {
        for (var i = 0; i < $scope.items.length; i++)
        {
            if ($scope.visao == 'T') {
                $scope.items[i].casa = $scope.items[i].totalCasa;
                $scope.items[i].fora = $scope.items[i].totalFora;
                $scope.items[i].total = $scope.items[i].totalTotal;
            }
            else
            {
                $scope.items[i].casa = $scope.items[i].mediaCasa;
                $scope.items[i].fora = $scope.items[i].mediaFora;
                $scope.items[i].total = $scope.items[i].mediaTotal;
            }

        }
    };

    $scope.MudarVisao = function (visao) {
        $scope.visao = visao;
        $scope.TrocarOrdenacao();        
    };
    
    $scope.ObterTimes = function () {
        var texto = '';
        for (var i = 0; i < $scope.timesSelecionados.length; i++)            
            texto = texto + $scope.timesSelecionados[i] + ',';
        return texto;
    };

    $scope.ObterPosicoes = function () {
        var texto = '';
        if ($scope.filtro.goleiroFiltro)
            texto = texto + '1,';
        if ($scope.filtro.lateralFiltro)
            texto = texto + '2,';
        if ($scope.filtro.zagueiroFiltro)
            texto = texto + '3,';
        if ($scope.filtro.meiaFiltro)
            texto = texto + '4,';
        if ($scope.filtro.atacanteFiltro)
            texto = texto + '5,';
        if ($scope.filtro.tecnicoFiltro)
            texto = texto + '6,';
        return texto;
    };
    
    $scope.TentarEscalarJogador = function (indice, jogador) {        
        var result = $scope.EscalarJogador(indice, jogador);

        if (result.sucesso)
            jogador.escalado = true;

        if (result.sucesso && !result.continuarEscalando)
            $state.go('app.escalacao');
    };

    $scope.TentarVenderJogador = function (jogador) {
        var result = $scope.VenderJogador(jogador);

        if (result)
            jogador.escalado = false;        
    };

    $scope.CarregarTela = function () {        
        if (sessionService.getStorage().posicaoId != null || sessionService.getStorage().posicaoId != undefined) {
            switch (sessionService.getStorage().posicaoId) {
                case 1:
                    $scope.filtro.goleiroFiltro = true;
                    $scope.filtro.rankingFiltro = "DD";
                    break;
                case 2:
                    $scope.filtro.lateralFiltro = true;
                    break;
                case 3:
                    $scope.filtro.zagueiroFiltro = true;
                    break;
                case 4:
                    $scope.filtro.meiaFiltro = true;
                    break;
                case 5:
                    $scope.filtro.atacanteFiltro = true;
                    break;
                case 6:
                    $scope.filtro.tecnicoFiltro = true;
                    $scope.filtro.rankingFiltro = "PT";
                    break;
            }
        }

        $scope.Pesquisar();
    };

    $scope.CarregarTela();
})

