﻿angular.module('ScoutCartolaApp.controllers').controller('ScoutTeamCtrl', function ($scope, $ionicModal, $http, $ionicLoading, cacheService, $filter) {

    var orderBy = $filter('orderBy');

    $scope.items = [];

    $scope.filtro = {
        "rankingFiltro": "G",
        "goleiroFiltro": false,
        "lateralFiltro": false,
        "zagueiroFiltro": false,
        "meiaFiltro": false,
        "atacanteFiltro": false,  
        "penaltiFiltro": false,
        "escanteioFiltro": false,
        "faltaFiltro": false
    };

    $scope.filtroModal = {
        "rankingFiltro": "G",
        "goleiroFiltro": false,
        "lateralFiltro": false,
        "zagueiroFiltro": false,
        "meiaFiltro": false,
        "atacanteFiltro": false,
        "penaltiFiltro": false,
        "escanteioFiltro": false,
        "faltaFiltro": false
    };

    $scope.timesSelecionados = [];
    
    $scope.classOrderGeral = '';
    $scope.classOrderCasa = '';
    $scope.classOrderFora = '';

    $scope.classButtonTotal = '';
    $scope.classButtonMedia = '';
    $scope.rankingAtual = '';

    $scope.visao = 'T';    

    // Create the login modal that we will use later
    $ionicModal.fromTemplateUrl('templates/filterJogador.html', {
        scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
    });

    $scope.Filtrar = function () {        
        $scope.modal.show();
    };

    $scope.Fechar = function () {
        $scope.modal.hide();
    };
    
    $scope.AplicarFiltros = function () {
        $scope.modal.hide();
        $scope.timesSelecionados = [];

        for (var i = 0; i < $scope.times.length; i++) {            
            if ($scope.times[i].checked)
                $scope.timesSelecionados.push($scope.times[i].id);
        }
        
        $scope.filtro.goleiroFiltro = $scope.filtroModal.goleiroFiltro;
        $scope.filtro.lateralFiltro = $scope.filtroModal.lateralFiltro;
        $scope.filtro.zagueiroFiltro = $scope.filtroModal.zagueiroFiltro;
        $scope.filtro.meiaFiltro = $scope.filtroModal.meiaFiltro;
        $scope.filtro.atacanteFiltro = $scope.filtroModal.atacanteFiltro;
        $scope.filtro.penaltiFiltro = $scope.filtroModal.penaltiFiltro;
        $scope.filtro.escanteioFiltro = $scope.filtroModal.escanteioFiltro;
        $scope.filtro.faltaFiltro = $scope.filtroModal.faltaFiltro;
        
        $scope.Pesquisar();
    };

    $scope.Pesquisar = function (visao) {
        
        var mudancaFiltro = false;
        if ($scope.rankingAtual != $scope.filtro.rankingFiltro) // se houver troca de indice
        {
            $scope.campoOrdem = 'total';
            $scope.ordemReversa = false; // inicializa com um valor padrão para evitar erros
            mudancaFiltro = true;
            $scope.rankingAtual = $scope.filtro.rankingFiltro;
        }

        $scope.ExibirLoading();

        var listaTimes = $scope.ObterTimes();
        var listaPosicoes = $scope.ObterPosicoes();
        
        var url = $scope.ObterRotaPadrao('API/ServicesTimes/ObterDadosEstatisticasConfrontos?'
            + 'codigoIndice=' + ($scope.rankingAtual == null || $scope.rankingAtual == '' ? $scope.filtro.rankingFiltro : $scope.rankingAtual)
            + '&codigoTime=' + listaTimes
            + '&versaoBase=' + cacheService.getVersaoBancoLocal());

        //var url = 'json/stats.json';

        $scope.WebApi(url,
            function (data) {

                if (typeof (data.sucesso) == 'undefined')
                    alert($scope.msgErroPadrao);

                if (data.sucesso) {
                    var resultCache = cacheService.tratarConsultaTimesComCache(data.data);

                    $scope.items = resultCache.data;

                    if (mudancaFiltro) // se houver troca de indice
                    {
                        if (resultCache.ordem == 'asc')
                            $scope.ordemReversa = false;
                        else
                            $scope.ordemReversa = true;
                    }

                    $scope.SetarEstilosOrdem();

                    $scope.classButtonTotal = 'button button-small button-customDisable';
                    $scope.classButtonMedia = 'button button-small button-customDisable';

                    if ($scope.visao == 'T')
                        $scope.classButtonTotal = 'button button-small button-custom';
                    else
                        $scope.classButtonMedia = 'button button-small button-custom';

                    $scope.AplicarOrdem();   
                }
                else {
                    alert(data.message);
                }
                
                
                $scope.EsconderLoading();
            });

    };
    
    $scope.Order = function (campoOrdem) {        
        $scope.ordemReversa = ($scope.campoOrdem == campoOrdem) ? !$scope.ordemReversa : $scope.ordemReversa;
        $scope.campoOrdem = campoOrdem;
        $scope.AplicarOrdem();
        $scope.SetarEstilosOrdem();
    };

    $scope.SetarEstilosOrdem = function () {
        $scope.classOrderGeral = 'fa fa-unsorted';
        $scope.classOrderCasa = 'fa fa-unsorted';
        $scope.classOrderFora = 'fa fa-unsorted';

        if ($scope.campoOrdem == 'casa') {
            if ($scope.ordemReversa)
                $scope.classOrderCasa = 'fa fa-sort-desc';
            else
                $scope.classOrderCasa = 'fa fa-sort-asc';
        }

        if ($scope.campoOrdem == 'total') {
            if ($scope.ordemReversa)
                $scope.classOrderGeral = 'fa fa-sort-desc';
            else
                $scope.classOrderGeral = 'fa fa-sort-asc';
        }

        if ($scope.campoOrdem == 'fora') {
            if ($scope.ordemReversa)
                $scope.classOrderFora = 'fa fa-sort-desc';
            else
                $scope.classOrderFora = 'fa fa-sort-asc';
        }
    };

    $scope.MudarVisao = function (visao) {
        $scope.visao = visao;
        $scope.AplicarOrdem();
    };
    
    $scope.ObterTimes = function () {
        var texto = '';
        for (var i = 0; i < $scope.timesSelecionados.length; i++)            
            texto = texto + $scope.timesSelecionados[i] + ',';
        return texto;
    };

    $scope.AplicarOrdem = function () {        
        for (var i = 0; i < $scope.items.length; i++) {
            if ($scope.visao == 'T') {
                $scope.items[i].casa = $scope.items[i].totalCasa;
                $scope.items[i].fora = $scope.items[i].totalFora;
                $scope.items[i].total = $scope.items[i].totalTotal;
            }
            else {
                $scope.items[i].casa = $scope.items[i].mediaCasa;
                $scope.items[i].fora = $scope.items[i].mediaFora;
                $scope.items[i].total = $scope.items[i].mediaTotal;
            }

            $scope.items = orderBy($scope.items, $scope.campoOrdem, $scope.ordemReversa);            
        }
    };

    $scope.ObterPosicoes = function () {
        var texto = '';
        if ($scope.filtro.goleiroFiltro)
            texto = texto + '1,';
        if ($scope.filtro.lateralFiltro)
            texto = texto + '2,';
        if ($scope.filtro.zagueiroFiltro)
            texto = texto + '3,';
        if ($scope.filtro.meiaFiltro)
            texto = texto + '4,';
        if ($scope.filtro.atacanteFiltro)
            texto = texto + '5,';
        if ($scope.filtro.tecnicoFiltro)
            texto = texto + '6,';
        return texto;
    };
    
    $scope.Pesquisar();
})

